<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\ApproverService;
use App\Http\Validators\ApproverValidator;
use App\Http\Services\RolesService;

class ApproverController extends BaseController
{
    protected $baseService;
    protected $validator;
    private $roles;

    /**
     * Approver constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new ApproverService();
        $this->validator = new ApproverValidator();
        $this->roles = new RolesService();

    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $this->validator->beforeInsert($request->all());
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->store($request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/approver")->with("successMessages", "Data has been created");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $this->data["header"] = ["id" => "id"
            , "roleId" => "roleId"
            , "formIdApprover" => "formIdApprover"
        ];
        $this->data["criteria"] = ["id" => "id"
            , "roleId" => "roleId"
            , "formIdApprover" => "formIdApprover"
        ];
        $this->data["ordering"] = ["id:asc" => "id"
            , "roleId:asc" => "roleId"
            , "formIdApprover:asc" => "formIdApprover"
        ];
        $this->data["approvers"] = $this->baseService->paging($request->all());
        return view("modules.approver.approver_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($id)
    {
        $this->data["roless"] = $this->roles->index();
        $this->data["approver"] = $this->baseService->show($id);
        return view("modules.approver.approver_edit", $this->data);
    }


    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->update($id, $request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/approver")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create()
    {
        $this->data["roless"] = $this->roles->index();
        return view("modules.approver.approver_create", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show($id)
    {
        $this->data["roless"] = $this->roles->index();
        $this->data["approver"] = $this->baseService->show($id);
        return view("modules.approver.approver_show", $this->data);
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }


}